Teach 'git pull' to handle --rebase=interactive
[git/dscho.git] / git-pull.sh
blobbe1b098be0801079c74ea114c8d3ae10b9f6466b
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 OPTIONS_SPEC=
11 . git-sh-setup
12 . git-sh-i18n
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
15 cd_to_toplevel
18 die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
24 else
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
29 die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
33 else
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
42 log_arg= verbosity= progress= recurse_submodules=
43 merge_args= edit=
44 curr_branch=$(git symbolic-ref -q HEAD)
45 curr_branch_short="${curr_branch#refs/heads/}"
46 rebase_options=
47 rebase=$(git config --bool branch.$curr_branch_short.rebase)
48 if test -z "$rebase"
49 then
50 rebase=$(git config --bool pull.rebase)
52 dry_run=
53 while :
55 case "$1" in
56 -q|--quiet)
57 verbosity="$verbosity -q" ;;
58 -v|--verbose)
59 verbosity="$verbosity -v" ;;
60 --progress)
61 progress=--progress ;;
62 --no-progress)
63 progress=--no-progress ;;
64 -n|--no-stat|--no-summary)
65 diffstat=--no-stat ;;
66 --stat|--summary)
67 diffstat=--stat ;;
68 --log|--no-log)
69 log_arg=$1 ;;
70 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
71 no_commit=--no-commit ;;
72 --c|--co|--com|--comm|--commi|--commit)
73 no_commit=--commit ;;
74 -e|--edit)
75 edit=--edit ;;
76 --no-edit)
77 edit=--no-edit ;;
78 --sq|--squ|--squa|--squas|--squash)
79 squash=--squash ;;
80 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
81 squash=--no-squash ;;
82 --ff)
83 no_ff=--ff ;;
84 --no-ff)
85 no_ff=--no-ff ;;
86 --ff-only)
87 ff_only=--ff-only ;;
88 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
89 --strateg=*|--strategy=*|\
90 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
91 case "$#,$1" in
92 *,*=*)
93 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
94 1,*)
95 usage ;;
97 strategy="$2"
98 shift ;;
99 esac
100 strategy_args="${strategy_args}-s $strategy "
102 -X*)
103 case "$#,$1" in
104 1,-X)
105 usage ;;
106 *,-X)
107 xx="-X $(git rev-parse --sq-quote "$2")"
108 shift ;;
109 *,*)
110 xx=$(git rev-parse --sq-quote "$1") ;;
111 esac
112 merge_args="$merge_args$xx "
114 -r|--r|--re|--reb|--reba|--rebas|--rebase)
115 rebase=true
117 --rebase=i|--rebase=interactive)
118 rebase_options=-i
119 rebase=true
121 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
122 rebase_options=
123 rebase=false
125 --recurse-submodules)
126 recurse_submodules=--recurse-submodules
128 --recurse-submodules=*)
129 recurse_submodules="$1"
131 --no-recurse-submodules)
132 recurse_submodules=--no-recurse-submodules
134 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
135 dry_run=--dry-run
137 -h|--help-all)
138 usage
141 # Pass thru anything that may be meant for fetch.
142 break
144 esac
145 shift
146 done
148 error_on_no_merge_candidates () {
149 exec >&2
150 for opt
152 case "$opt" in
153 -t|--t|--ta|--tag|--tags)
154 echo "Fetching tags only, you probably meant:"
155 echo " git fetch --tags"
156 exit 1
157 esac
158 done
160 if test true = "$rebase"
161 then
162 op_type=rebase
163 op_prep=against
164 else
165 op_type=merge
166 op_prep=with
169 curr_branch=${curr_branch#refs/heads/}
170 upstream=$(git config "branch.$curr_branch.merge")
171 remote=$(git config "branch.$curr_branch.remote")
173 if [ $# -gt 1 ]; then
174 if [ "$rebase" = true ]; then
175 printf "There is no candidate for rebasing against "
176 else
177 printf "There are no candidates for merging "
179 echo "among the refs that you just fetched."
180 echo "Generally this means that you provided a wildcard refspec which had no"
181 echo "matches on the remote end."
182 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
183 echo "You asked to pull from the remote '$1', but did not specify"
184 echo "a branch. Because this is not the default configured remote"
185 echo "for your current branch, you must specify a branch on the command line."
186 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
187 . git-parse-remote
188 error_on_missing_default_upstream "pull" $op_type $op_prep \
189 "git pull <remote> <branch>"
190 else
191 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
192 echo "from the remote, but no such ref was fetched."
194 exit 1
197 test true = "$rebase" && {
198 if ! git rev-parse -q --verify HEAD >/dev/null
199 then
200 # On an unborn branch
201 if test -f "$GIT_DIR/index"
202 then
203 die "$(gettext "updating an unborn branch with changes added to the index")"
205 else
206 require_clean_work_tree "pull with rebase" "Please commit or stash them."
208 oldremoteref= &&
209 . git-parse-remote &&
210 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
211 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
212 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
214 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
215 then
216 oldremoteref="$reflog"
217 break
219 done
221 orig_head=$(git rev-parse -q --verify HEAD)
222 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
223 test -z "$dry_run" || exit 0
225 curr_head=$(git rev-parse -q --verify HEAD)
226 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
227 then
228 # The fetch involved updating the current branch.
230 # The working tree and the index file is still based on the
231 # $orig_head commit, but we are merging into $curr_head.
232 # First update the working tree to match $curr_head.
234 eval_gettextln "Warning: fetch updated the current branch head.
235 Warning: fast-forwarding your working tree from
236 Warning: commit \$orig_head." >&2
237 git update-index -q --refresh
238 git read-tree -u -m "$orig_head" "$curr_head" ||
239 die "$(eval_gettext "Cannot fast-forward your working tree.
240 After making sure that you saved anything precious from
241 $ git diff \$orig_head
242 output, run
243 $ git reset --hard
244 to recover.")"
248 merge_head=$(sed -e '/ not-for-merge /d' \
249 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
250 tr '\012' ' ')
252 case "$merge_head" in
254 error_on_no_merge_candidates "$@"
256 ?*' '?*)
257 if test -z "$orig_head"
258 then
259 die "$(gettext "Cannot merge multiple branches into empty head")"
261 if test true = "$rebase"
262 then
263 die "$(gettext "Cannot rebase onto multiple branches")"
266 esac
268 if test -z "$orig_head"
269 then
270 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
271 git read-tree -m -u HEAD || exit 1
272 exit
275 if test true = "$rebase"
276 then
277 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
278 if test "$oldremoteref" = "$o"
279 then
280 unset oldremoteref
284 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
285 case "$rebase" in
286 true)
287 eval="git-rebase $rebase_options $diffstat $strategy_args $merge_args"
288 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
291 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
292 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
293 eval="$eval \"\$merge_name\" HEAD $merge_head"
295 esac
296 eval "exec $eval"